;; Exercise 4.50.  Using ramb for generating sentences stops the
;; generation getting stuck in the out recursion.
;;; Amb-Eval input:
(set! parse-word generate-word-ramb)

;;; Starting a new problem 


;;; Amb-Eval value:
0
ok

;;; Amb-Eval input:
(parse '())

;;; Starting a new problem 


;;; Amb-Eval value:
0
(simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies))

;;; Amb-Eval input:
try-again


;;; Amb-Eval value:
4
(compound-sentence (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies)) (connective and) (simple-sentence (simple-noun-phrase (article a) ((noun cat))) (verb studies)))

;;; Amb-Eval input:
try-again


;;; Amb-Eval value:
8
(compound-sentence (compound-sentence (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies)) (connective and) (simple-sentence (simple-noun-phrase (article a) ((noun cat))) (verb studies))) (connective and) (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies)))

;;; Amb-Eval input:
try-again


;;; Amb-Eval value:
13
(compound-sentence (compound-sentence (compound-sentence (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies)) (connective and) (simple-sentence (simple-noun-phrase (article a) ((noun cat))) (verb studies))) (connective and) (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies))) (connective and) (simple-sentence (simple-noun-phrase (article the) ((noun cat))) (verb sleeps)))

;;; Amb-Eval input:
try-again


;;; Amb-Eval value:
18
(compound-sentence (compound-sentence (compound-sentence (compound-sentence (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies)) (connective and) (simple-sentence (simple-noun-phrase (article a) ((noun cat))) (verb studies))) (connective and) (simple-sentence (simple-noun-phrase (article the) ((noun professor))) (verb studies))) (connective and) (simple-sentence (simple-noun-phrase (article the) ((noun cat))) (verb sleeps))) (connective and) (simple-sentence (simple-noun-phrase (article the) ((noun student))) (verb studies)))

;;; Amb-Eval input:


;; Exercise 4.51:

;;; Amb-Eval input:
(define count 0)

          (let ((x (an-element-of '(a b c)))
                (y (an-element-of '(a b c))))
            (permanent-set! count (+ count 1))
            (require (not (eq? x y)))
            (list x y count))

;;; Starting a new problem 


;;; Amb-Eval value:
0
ok

;;; Amb-Eval input:

;;; Starting a new problem 


;;; Amb-Eval value:
0
(a b 2)

;;; Amb-Eval input:
try-again


;;; Amb-Eval value:
3
(a c 3)

;; Using set! instead of permanent-set! resets the counter back to 0
;; on each backtrack of x or y, so will always be 1.


;; Exercise 4.52

;;; Amb-Eval input:

;;; Amb-Eval input:
(if-fail (let ((x (an-element-of '(1 3 5))))
           (require (even? x))
           x)
         'all-odd)

;;; Starting a new problem 


;;; Amb-Eval value:
0
all-odd

;;; Amb-Eval input:
(if-fail (let ((x (an-element-of '(1 3 5 8))))
           (require (even? x))
           x)
         'all-odd)

;;; Starting a new problem 


;;; Amb-Eval value:
0
8

;;; Amb-Eval input:
try-again


;;; Amb-Eval value:
4
all-odd

;;; Amb-Eval input:
try-again

;;; There are no more values of
7
(if-fail (let ((x (an-element-of (quote (1 3 5 8))))) (require (even? x)) x) (quote all-odd))


;; Exercise 4.53

(define (square x) (* x x))

(define (smallest-divisor n)
  (find-divisor n 2))

(define (find-divisor n test-divisor)
  (cond ((> (square test-divisor) n) n)
        ((divides? test-divisor n) test-divisor)
        (else (find-divisor n (+ test-divisor 1)))))

(define (divides? a b)
  (= (remainder b a) 0))

(define (prime? n)
  (= n (smallest-divisor n)))

(define (prime-sum-pair list1 list2)
  (let ((a (an-element-of list1))
        (b (an-element-of list2)))
    (require (prime? (+ a b)))
    (list a b)))


;;; Amb-Eval input:
(let ((pairs '()))
  (if-fail (let ((p (prime-sum-pair '(1 3 5 8) '(20 35 110))))
             (permanent-set! pairs (cons p pairs))
             (amb))
           pairs))

;;; Starting a new problem 


;;; Amb-Eval value:
0
((8 35) (3 110) (3 20))

;; The call to prime-sum-pair succeeds for each of the pairs that
;; satisfy the condition.  On success, the let body is entered, which
;; conses the current result onto pairs.  Then the (amb) call forces
;; back tracking to the next solution.  For each of these, pairs is
;; augmented with the candidate solution, until there are no more
;; solutions.  At this point, the let expression fails, and if-fail
;; causes pairs to be evaluated.


